/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 18/10/22.
//

#ifndef FGGL_DEMO_INCLUDE_MODELS_VIEWER_HPP
#define FGGL_DEMO_INCLUDE_MODELS_VIEWER_HPP

#include "fggl/scenes/game.hpp"
#include "fggl/assets/types.hpp"

namespace demo {

	class Viewer : public fggl::scenes::Game {

		public:
			explicit Viewer(fggl::App& app);

			void activate() override;
			void deactivate() override;

			void update(float dt) override;
			void render(fggl::gfx::Graphics& gfx) override;

		private:
			fggl::entity::EntityID m_model = fggl::entity::INVALID;
			std::vector< fggl::assets::AssetID> m_assets;
			uint64_t m_lastAsset = 0;
			bool m_debug = false;

			void cycleAsset(uint64_t asset);

	};
}

#endif //FGGL_DEMO_INCLUDE_MODELS_VIEWER_HPP
